package com.fump.bearbeiten;

/**
*  @author Tobias Becker (tbecker), Joerg Dieckmann (dieck)
*  @version $Id: 
*
*
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import com.fump.*;
import com.fump.bearbeiten.*;
import java.io.*;
import javax.activation.*;

public class AnhaengselDialog
{
	private InputStream content;
	private FileOutputStream out;
	private NeueMail neueMail;
	private VorschauPanel vorschau;
	private File datei;
	
	public AnhaengselDialog(NeueMail neueMail,InputStream content,String dateiName)
	{
		this.content = content;
		this.neueMail = neueMail;

		String[] option = {"Ja","Nein"};
		int ergebnis1 = JOptionPane.showOptionDialog(neueMail,"Moechten Sie das Attachment \""+dateiName+"\" abspeichern?","Eine kurze Frage haette ich:",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,null,option,option[0]);
		System.out.println(ergebnis1 +" "+ JOptionPane.YES_OPTION);

		if (ergebnis1 == JOptionPane.YES_OPTION)
		{
			JFileChooser speichernDialog = new JFileChooser();
			speichernDialog.setSelectedFile(new File(dateiName));
			int ergebnis2 = speichernDialog.showSaveDialog(neueMail);
			System.out.println(ergebnis2 +" "+ JFileChooser.APPROVE_OPTION);

			if (ergebnis2 == JFileChooser.APPROVE_OPTION)
			{
				InputStreamReader input = new InputStreamReader(content);
				datei = speichernDialog.getSelectedFile();
				try{
					out = new FileOutputStream(datei);
					int gelesen =0;
					while((gelesen=content.read())!=-1)
					{
						out.write(gelesen);
//						System.out.println("es wurde was geschrieben "+gelesen);
					}
					out.close();
				}
				catch (IOException io) {System.out.println("AnhaengselDialog.java: Datei zuende o.. ");}
				catch (Exception e) {System.out.println("AnhaengselDialog.java: Anderer Fehler");}
			}
		}
	}


	public AnhaengselDialog(VorschauPanel vorschau,InputStream content,String dateiName)
	{
		this.content = content;
		this.vorschau = vorschau;

		String[] option = {"Ja","Nein"};
		int ergebnis1 = JOptionPane.showOptionDialog(vorschau,"Moechten Sie das Attachment \""+dateiName+"\" abspeichern?","Eine kurze Frage haette ich:",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,null,option,option[0]);
		System.out.println(ergebnis1 +" "+ JOptionPane.YES_OPTION);

		if (ergebnis1 == JOptionPane.YES_OPTION)
		{
			JFileChooser speichernDialog = new JFileChooser();
			speichernDialog.setSelectedFile(new File(dateiName));
			int ergebnis2 = speichernDialog.showSaveDialog(vorschau);
			System.out.println(ergebnis2 +" "+ JFileChooser.APPROVE_OPTION);

			if (ergebnis2 == JFileChooser.APPROVE_OPTION)
			{
				InputStreamReader input = new InputStreamReader(content);
				datei = speichernDialog.getSelectedFile();
				try{
					out = new FileOutputStream(datei);
					int gelesen =0;
					while((gelesen=content.read())!=-1)
					{
						out.write(gelesen);
//						System.out.println("es wurde was geschrieben "+gelesen);
					}
					out.close();
				}
				catch (IOException io) {System.out.println("AnhaengselDialog.java: Datei zuende o.. ");}
				catch (Exception e) {System.out.println("AnhaengselDialog.java: Anderer Fehler");}
			}
		}
	}
}
				
